package cn.iocoder.yudao.module.iot.service.alert;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.module.iot.controller.admin.alert.vo.*;
import cn.iocoder.yudao.module.iot.dal.dataobject.alert.AlertDO;
import cn.iocoder.yudao.module.iot.dal.dataobject.alertrecord.AlertRecordDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

/**
 * 告警配置 Service 接口
 *
 * @author 内蒙必硕
 */
public interface AlertService {

    /**
     * 创建告警配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createAlert(@Valid AlertSaveReqVO createReqVO);

    /**
     * 更新告警配置
     *
     * @param updateReqVO 更新信息
     */
    void updateAlert(@Valid AlertSaveReqVO updateReqVO);

    /**
     * 删除告警配置
     *
     * @param id 编号
     */
    void deleteAlert(Long id);

    /**
     * 获得告警配置
     *
     * @param id 编号
     * @return 告警配置
     */
    AlertDO getAlert(Long id);

    /**
     * 获得告警配置分页
     *
     * @param pageReqVO 分页查询
     * @return 告警配置分页
     */
    PageResult<AlertDO> getAlertPage(AlertPageReqVO pageReqVO);

    // ==================== 子表（告警记录） ====================

    /**
     * 获得告警记录分页
     *
     * @param pageReqVO 分页查询
     * @param alertId 告警ID
     * @return 告警记录分页
     */
    PageResult<AlertRecordDO> getAlertRecordPage(PageParam pageReqVO, Long alertId);

    /**
     * 创建告警记录
     *
     * @param alertRecord 创建信息
     * @return 编号
     */
    Long createAlertRecord(@Valid AlertRecordDO alertRecord);

    /**
     * 更新告警记录
     *
     * @param alertRecord 更新信息
     */
    void updateAlertRecord(@Valid AlertRecordDO alertRecord);

    /**
     * 删除告警记录
     *
     * @param id 编号
     */
    void deleteAlertRecord(Long id);

	/**
	 * 获得告警记录
	 *
	 * @param id 编号
     * @return 告警记录
	 */
    AlertRecordDO getAlertRecord(Long id);

}